#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire800three4xi.py">
#<abstract4xi abstract = "fires to direction three and to distance 800"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire800three4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2three8004xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

       
# -------------------------------------------------------------------------------------------------
# SHOT2THREE - COORDINATE SIGNS OF SHOOT2THREE4XI: (X + ,Y + ,Z - ) - STUBS ONLY - ALL ARE IN FILES
# -------------------------------------------------------------------------------------------------    

shot2three8004xi = {
                1:'0x15y-799z',
                2:'0x23y-799z',
                3:'0x776y-192z',
                4:'0x7y-799z',
                5:'100x229y-759z',
                6:'101x719y-334z',
                7:'104x98y-787z',
                8:'108x691y-565z',
                9:'115x230y-757z',
                10:'115x97y-785z',
                11:'117x669y-421z',
                12:'11x666y-441z',
                13:'122x772y-168z',
                14:'126x96y-784z',
                15:'129x613y-496z',
                16:'131x230y-754z',
                17:'137x93y-782z',
                18:'139x716y-326z',
                19:'13x16y-799z',
                20:'13x54y-798z',
                21:'147x229y-752z',
                22:'153x666y-414z',
                23:'162x610y-490z',
                24:'162x766y-161z',
                25:'163x227y-749z',
                26:'177x711y-319z',
                27:'179x224y-746z',
                28:'189x661y-407z',
                29:'18x61y-797z',
                30:'195x606y-483z',
                31:'196x220y-743z',
                32:'19x21y-799z',
                33:'203x758y-153z',
                34:'20x203y-773z',
                35:'212x215y-740z',
                36:'215x704y-312z',
                37:'225x654y-400z',
                38:'229x208y-737z',
                39:'229x599y-477z',
                40:'243x748y-145z',
                41:'245x201y-734z',
                42:'24x67y-796z',
                43:'252x695y-304z',
                44:'25x719y-348z',
                45:'260x645y-393z',
                46:'261x192y-731z',
                47:'262x591y-471z',
                48:'26x25y-799z',
                49:'277x182y-727z',
                50:'282x735y-137z',
                51:'290x683y-297z',
                52:'294x580y-464z',
                53:'295x634y-386z',
                54:'2x31y-799z',
                55:'2x3y-799z',
                56:'30x73y-796z',
                57:'31x209y-771z',
                58:'321x721y-129z',
                59:'326x670y-290z',
                60:'327x568y-458z',
                61:'330x621y-379z',
                62:'33x29y-798z',
                63:'358x554y-451z',
                64:'358x704y-121z',
                65:'362x654y-282z',
                66:'364x606y-372z',
                67:'37x79y-795z',
                68:'389x538y-444z',
                69:'395x685y-113z',
                70:'397x590y-365z',
                71:'398x637y-275z',
                72:'40x777y-184z',
                73:'41x32y-798z',
                74:'420x520y-438z',
                75:'430x571y-358z',
                76:'431x665y-105z',
                77:'432x617y-267z',
                78:'449x501y-431z',
                79:'44x215y-769z',
                80:'45x83y-794z',
                81:'461x550y-351z',
                82:'465x596y-260z',
                83:'466x642y-97z',
                84:'46x669y-434z',
                85:'478x480y-424z',
                86:'492x528y-344z',
                87:'498x572y-252z',
                88:'49x35y-797z',
                89:'500x617y-90z',
                90:'506x457y-417z',
                91:'521x504y-336z',
                92:'529x547y-244z',
                93:'532x432y-411z',
                94:'532x591y-82z',
                95:'549x478y-329z',
                96:'54x88y-793z',
                97:'557x406y-404z',
                98:'558x521y-237z',
                99:'563x563y-74z',
                100:'576x451y-322z',
                101:'57x219y-767z',
                102:'587x492y-229z',
                103:'592x533y-66z',
                104:'5x39y-799z',
                105:'602x422y-315z',
                106:'613x462y-221z',
                107:'620x502y-58z',
                108:'639x431y-214z',
                109:'63x720y-341z',
                110:'63x91y-792z',
                111:'645x469y-50z',
                112:'71x223y-764z',
                113:'72x94y-791z',
                114:'7x10y-799z',
                115:'81x775y-176z',
                116:'82x670y-428z',
                117:'82x96y-789z',
                118:'85x226y-762z',
                119:'8x46y-798z',
                120:'93x97y-788z',
                121:'9x196y-775z'}
                
 
# -----------------------------------------------------------------------------------------------------------
#<function4xi function = "fire800three4xi" usage = "target function for chargethree4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------------------------
def fire800three4xi(queue2three, consumer_channel2three, publisher_channel2three):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE800THREE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE800THREE4XI -  QUEUE2THREE: ", queue2three)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE800THREE4XI -  CONSUMER_CHANNEL2THREE: ", consumer_channel2three)
        #  
              
        print("\n (STEP 1A4/33) OF FIRE800THREE4XI -  PUBLISHER_CHANNEL2THREE: ", publisher_channel2three)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE800THREE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2three.put(shot2three8004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE800THREE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE800THREE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2THREE: ", queue2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE800THREE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4three = "<ack2put4xi>queue2three8shot2three8004xi</ack2put4xi>"
        else:
            message2send4three = "<nack2put4xi>queue2three8shot2three8004xi</nack2put4xi>" 
            
        publisher_channel2three.send(message2send4three)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE800THREE4XI -  SENT MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE800THREE4XI *** FAILED TO SEND MESSAGE2SEND4THREE: ", message2send4three, " TO PUBLISHER_CHANNEL2THREE: ", publisher_channel2three, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE800THREE4XI - RETURNING QUEUE OBJECT QUEUE2THREE: ", queue2three, " - TIME: ", time4xi())  
        # 
            
    return queue2three    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire800three4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                               
                